package apis

import (
    "fmt"

	"github.com/gin-gonic/gin"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type LineUduncoin struct {
	api.Api
}

// GetPage 获取【u盾支持的币种信息】列表
// @Summary 获取【u盾支持的币种信息】列表
// @Description 获取【u盾支持的币种信息】列表
// @Tags 【u盾支持的币种信息】
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.LineUduncoin}} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-uduncoin [get]
// @Security Bearer
func (e LineUduncoin) GetPage(c *gin.Context) {
    req := dto.LineUduncoinGetPageReq{}
    s := service.LineUduncoin{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
   	if err != nil {
   		e.Logger.Error(err)
   		e.Error(500, err, err.Error())
   		return
   	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.LineUduncoin, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取【u盾支持的币种信息】失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取【u盾支持的币种信息】
// @Summary 获取【u盾支持的币种信息】
// @Description 获取【u盾支持的币种信息】
// @Tags 【u盾支持的币种信息】
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.LineUduncoin} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-uduncoin/{id} [get]
// @Security Bearer
func (e LineUduncoin) Get(c *gin.Context) {
	req := dto.LineUduncoinGetReq{}
	s := service.LineUduncoin{}
    err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.LineUduncoin

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取【u盾支持的币种信息】失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK( object, "查询成功")
}

// Insert 创建【u盾支持的币种信息】
// @Summary 创建【u盾支持的币种信息】
// @Description 创建【u盾支持的币种信息】
// @Tags 【u盾支持的币种信息】
// @Accept application/json
// @Product application/json
// @Param data body dto.LineUduncoinInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/line-uduncoin [post]
// @Security Bearer
func (e LineUduncoin) Insert(c *gin.Context) {
    req := dto.LineUduncoinInsertReq{}
    s := service.LineUduncoin{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建【u盾支持的币种信息】失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改【u盾支持的币种信息】
// @Summary 修改【u盾支持的币种信息】
// @Description 修改【u盾支持的币种信息】
// @Tags 【u盾支持的币种信息】
// @Accept application/json
// @Product application/json
// @Param id path int true "id"
// @Param data body dto.LineUduncoinUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/line-uduncoin/{id} [put]
// @Security Bearer
func (e LineUduncoin) Update(c *gin.Context) {
    req := dto.LineUduncoinUpdateReq{}
    s := service.LineUduncoin{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改【u盾支持的币种信息】失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "修改成功")
}

// Delete 删除【u盾支持的币种信息】
// @Summary 删除【u盾支持的币种信息】
// @Description 删除【u盾支持的币种信息】
// @Tags 【u盾支持的币种信息】
// @Param data body dto.LineUduncoinDeleteReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/line-uduncoin [delete]
// @Security Bearer
func (e LineUduncoin) Delete(c *gin.Context) {
    s := service.LineUduncoin{}
    req := dto.LineUduncoinDeleteReq{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除【u盾支持的币种信息】失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "删除成功")
}
